<?php
function create() {
header('Content-Type: text/html; charset=utf-8');
session_start();


include_once 'classes\StandardWS.php';
include_once 'classes\payzenApi.php';
$config= parse_ini_file('config.ini',true);	

$certificate = $config['webservices']['key'];	
$vads=new StandardWS;
$createInfo = new paymentCreationInfo;

//Permet dans ce code d'exemple de dfinir si une authentification 3DS a t ralise par le marchand au pralable.
$threeDS_performed = false;
	
	/****************************************************************/
	$createInfo->paymentGeneralInfo = new createPaymentGeneralInfo();	
		$createInfo->paymentGeneralInfo->siteId = $config['webservices']['siteId'];			
		$createInfo->paymentGeneralInfo->transmissionDate = new DateTime('now',new DateTimeZone('UTC'));
		$createInfo->paymentGeneralInfo->transactionId = _generateTransId();
		$createInfo->paymentGeneralInfo->paymentSource = $config['webservices']['paymentSource'];
		
		if (!empty($_POST['orderId'])) $createInfo->paymentGeneralInfo->orderId = $_POST['orderId']; 		
		if (!empty($_POST['orderInfo1'])) $createInfo->paymentGeneralInfo->orderInfo = $_POST['orderInfo']; 			
		if (!empty($_POST['orderInfo2'])) $createInfo->paymentGeneralInfo->orderInfo2 = $_POST['orderInfo2'];
		if (!empty($_POST['orderInfo3'])) $createInfo->paymentGeneralInfo->orderInfo3 = $_POST['orderInfo3']; 						
		if (!empty($_POST['amount'])) $createInfo->paymentGeneralInfo->amount = ($_POST['amount']*100); 
				
		$createInfo->paymentGeneralInfo->currency = $config['webservices']['currency'];				
		$createInfo->paymentGeneralInfo->validationMode = $config['webservices']['validationMode'];		
		
		//date de remise fixe  J+2 dans notre exemple
		$createInfo->paymentGeneralInfo->presentationDate = new DateTime('now',new DateTimeZone('UTC'));
		$createInfo->paymentGeneralInfo->presentationDate->add(new DateInterval('P2D'));
		
	/****************************************************************/	
	$createInfo->cardInfo= new createCardInfo();		
		if (!empty($_POST['cardNumber'])) $createInfo->cardInfo->cardNumber=$_POST['cardNumber'];
		if (!empty($_POST['cardNetwork'])) $createInfo->cardInfo->cardNetwork=$_POST['cardNetwork'];		
		if (!empty($_POST['expiryMonth'])) $createInfo->cardInfo->expiryMonth=$_POST['expiryMonth'];
		if (!empty($_POST['expiryYear'])) $createInfo->cardInfo->expiryYear=$_POST['expiryYear'];				
		if (!empty($_POST['cvv'])) $createInfo->cardInfo->cvv=$_POST['cvv'];	
		if (!empty($_POST['cardIdent'])) $createInfo->cardInfo->cardIdent=$_POST['cardIdent'];		
		if(!empty($config['webservices']['contractNumber'])) $createInfo->cardInfo->contractNumber = $config['webservices']['contractNumber'];		
		
		/* paymentOptionCode - rserv  un usage spcifique - ne pas utiliser
			$createInfo->cardInfo->paymentOptionCode = '';
		*/
	/****************************************************************/	
	// Le champ threeDsResult ne doit tre envoy que si une authentification 3D-S a t ralise	
	if($threeDS_performed == true){
	
		$createInfo->threeDsResult= new threeDsResult();
			if (!empty($_POST['threeDSBrand'])) $createInfo->threeDsResult->threeDSBrand=$_POST['threeDSBrand'];
			if (!empty($_POST['threeDSEnrolled'])) $createInfo->threeDsResult->threeDSEnrolled=$_POST['threeDSEnrolled'];
			if (!empty($_POST['threeDSStatus'])) $createInfo->threeDsResult->threeDSStatus=$_POST['threeDSStatus'];
			if (!empty($_POST['threeDSEci'])) $createInfo->threeDsResult->threeDSEci=$_POST['threeDSEci'];
			if (!empty($_POST['threeDSXid'])) $createInfo->threeDsResult->threeDSXid=$_POST['threeDSXid'];
			if (!empty($_POST['threeDSCavv'])) $createInfo->threeDsResult->threeDSCavv=$_POST['threeDSCavv'];
			if (!empty($_POST['threeDSCavvAlgorithm'])) $createInfo->threeDsResult->threeDSCavvAlgorithm=$_POST['threeDSCavvAlgorithm'];		
		
	}
	
	/****************************************************************/	
	/**
	*subPaymentInfo - rserv  un usage spcifique - ne pas utiliser
	
		$createInfo->subPaymentInfo= new createSubPaymentInfo();
	*/	
	/****************************************************************/
	$createInfo->customerInfo = new createCustomerInfo();
		if (!empty($_POST['customerId'])) $createInfo->customerInfo->customerId=$_POST['customerId'];		
		if (!empty($_POST['customerTitle'])) $createInfo->customerInfo->customerTitle=$_POST['customerTitle'];		
		if (!empty($_POST['customerStatus'])) $createInfo->customerInfo->customerStatus=$_POST['customerStatus'];		
		if (!empty($_POST['customerName'])) $createInfo->customerInfo->customerName=$_POST['customerName'];
		if (!empty($_POST['customerPhone'])) $createInfo->customerInfo->customerPhone=$_POST['customerPhone'];	
		if (!empty($_POST['customerCellPhone'])) $createInfo->customerInfo->customerCellPhone=$_POST['customerCellPhone'];		
		if (!empty($_POST['customerEmail'])) $createInfo->customerInfo->customerEmail=$_POST['customerEmail'];
		if (!empty($_POST['customerAddressNumber'])) $createInfo->customerInfo->customerAddressNumber=$_POST['customerAddressNumber'];
		if (!empty($_POST['customerAddress'])) $createInfo->customerInfo->customerAddress=$_POST['customerAddress'];
		if (!empty($_POST['customerDistrict'])) $createInfo->customerInfo->customerDistrict=$_POST['customerDistrict'];
		if (!empty($_POST['customerZip'])) $createInfo->customerInfo->customerZip=$_POST['customerZip'];
		if (!empty($_POST['customerCity'])) $createInfo->customerInfo->customerCity=$_POST['customerCity'];
		if (!empty($_POST['customerState'])) $createInfo->customerInfo->customerState=$_POST['customerState'];
		if (!empty($_POST['customerCountry'])) $createInfo->customerInfo->customerCountry=$_POST['customerCountry'];
		if (!empty($_POST['language'])) $createInfo->customerInfo->language=$_POST['language'];		
		$createInfo->customerInfo->customerIP = $_SERVER['REMOTE_ADDR'];		
		$createInfo->customerInfo->customerSendEmail = $config['webservices']['sendMail'];
		
		/**
		* Champs extInfo permettant de d'envoyer le contenu du panier
		*/	
			/* 
				$nb_product= new extInfo();
				$nb_product->key="nb_product";
				$nb_product->value="1";
				
				$product_amount0 = new extInfo();
				$product_amount0->key="amount";
				$product_amount0->value="1000";
				
				$product_label0 = new extInfo();
				$product_label0->key="label";
				$product_label0->value="Iphone12";
				
				$product_qty0 = new extInfo();
				$product_qty0->key="qty";
				$product_qty0->value="1";
				
				$product_ref0 = new extInfo();
				$product_ref0->key="";
				$product_ref0->value="";	
				
									
			$extInfo= array($nb_product,$product_amount0, $product_label0, $product_qty0,$product_ref0);		
		$createInfo->customerInfo->extInfo= $extInfo;
		*/
	/****************************************************************/	
	$createInfo->shippingInfo = new createShippingInfo();
		if (!empty($_POST['shippingCity'])) $createInfo->shippingInfo->shippingCity=$_POST['shippingCity'];
		if (!empty($_POST['shippingCountry'])) $createInfo->shippingInfo->shippingCountry=$_POST['shippingCountry'];
		if (!empty($_POST['shippingDeliveryCompanyName'])) $createInfo->shippingInfo->shippingDeliveryCompanyName=$_POST['shippingDeliveryCompanyName'];
		if (!empty($_POST['shippingName'])) $createInfo->shippingInfo->shippingName=$_POST['shippingName'];
		if (!empty($_POST['shippingPhone'])) $createInfo->shippingInfo->shippingPhone=$_POST['shippingPhone'];
		if (!empty($_POST['shippingSpeed'])) $createInfo->shippingInfo->shippingSpeed=$_POST['shippingSpeed'];
		if (!empty($_POST['shippingState'])) $createInfo->shippingInfo->shippingState=$_POST['shippingState'];
		if (!empty($_POST['shippingStatus'])) $createInfo->shippingInfo->shippingStatus=$_POST['shippingStatus'];
		if (!empty($_POST['shippingStreetNumber'])) $createInfo->shippingInfo->shippingStreetNumber=$_POST['shippingStreetNumber'];
		if (!empty($_POST['shippingStreet'])) $createInfo->shippingInfo->shippingStreet=$_POST['shippingStreet'];
		if (!empty($_POST['shippingStreet2'])) $createInfo->shippingInfo->shippingStreet2=$_POST['shippingStreet2'];
		if (!empty($_POST['shippingDistrict'])) $createInfo->shippingInfo->shippingDistrict=$_POST['shippingDistrict'];
		if (!empty($_POST['shippingType'])) $createInfo->shippingInfo->shippingType=$_POST['shippingType'];
		if (!empty($_POST['shippingZipCode'])) $createInfo->shippingInfo->shippingZipCode=$_POST['shippingZipCode'];		
	/****************************************************************/
	$createInfo->extraInfo = new createExtraInfo();
		$createInfo->extraInfo->ctxMode = $config['webservices']['ctxMode'];
		$createInfo->extraInfo->browserUserAgent = $_SERVER['HTTP_USER_AGENT'];
		$createInfo->extraInfo->browserAccept = $_SERVER['HTTP_ACCEPT'];
	/****************************************************************/
		
	
	$createResponse= new transactionInfo();	
	try {
		$createResponse=$vads->create($createInfo, $certificate);
	}catch (Exception $e){
                 echo $e->getMessage();
				 }
	getJsessionId($vads);
	/*Affichage des logs XML*/
	if ($config['webservices']['debugXML']=='ON'){
		echo "<hr> [Request Header] <br/>", htmlspecialchars($vads->__getLastRequestHeaders()), "<br/>";
		echo "<hr> [Request] <br/>", htmlspecialchars($vads->__getLastRequest()), "<br/>";	
		echo "<hr> [Response Header]<br/>", htmlspecialchars($vads->__getLastResponseHeaders()), "<br/>";
		echo "<hr> [Response]<br/>", htmlspecialchars($vads->__getLastResponse()), "<br/>";
		echo '<hr>';		
		
	}	
	
	//Vrification de la signature de la rponse
	$response=checkTransactionInfoResponse($createResponse, $certificate);
	
	if ($response['result'] == 1){	
	//signature valide
	
		//Vrification de l'errorCode
		//Si l'errorCode =0 on continu
		//sinon erreur technique
		
		if ($createResponse->errorCode==0){
		
			//Analyse du rsultat du paiement
			//si tranasctionStatus = 8 ou 2 => Paiement refus
			
			if (($createResponse->transactionStatus==8) OR ($createResponse->transactionStatus==2)){
			//Paiement refus
			echo "Votre Paiement a t refus";
			
			}else{
			//Paiement accept
			
			echo "Merci pour votre achat";
			
			}
			
			/* 
			 *
			 * Ajouter ici le code pour mettre  jour votre base de donnes.
			 *
			 */
						
		}
		else{
		//erreur technique
			echo 'erreur technique';
		}
	}
	else{
	//signature invalide - Risque de fraude
		//La rponse est frauduleuse. On s'arrte	
		echo "Erreur technique";
		die;
	}
	
	return $createResponse;
}
	
	
	
?>