<?PHP
function finalizeWithThreeDS(){
	header('Content-Type: text/html; charset=utf-8');
	session_start();
	include_once 'classes\StandardWS.php';
	include_once 'classes\payzenApi.php';
	$config= parse_ini_file('config.ini',true);	
		
		$vads= new StandardWS;
		$certificate = $config['webservices']['key'];	
		
		

		if (isset ($_POST['MD']) AND (isset ($_POST['PaRes']))){
			list($JSESSIONID, $requestId) = explode("+",$_POST['MD']);
			$pares = str_replace("\r\n","",$_POST['PaRes'],$count);;

			setJsessionId($vads);

			$finalizeWithThreeDSResponse = new transactionInfo();
			$finalizeWithThreeDSResponse = $vads->finalizeWithThreeDS($requestId, $pares, $certificate);

			
			/*Affichage des logs XML*/
				if ($config['webservices']['debugXML']=='ON'){
					echo "<hr> [Request Header] <br/>", htmlspecialchars($vads->__getLastRequestHeaders()), "<br/>";
					echo "<hr> [Request] <br/>", htmlspecialchars($vads->__getLastRequest()), "<br/>";	
					echo "<hr> [Response Header]<br/>", htmlspecialchars($vads->__getLastResponseHeaders()), "<br/>";
					echo "<hr> [Response]<br/>", htmlspecialchars($vads->__getLastResponse()), "<br/>";
					echo '<hr>';
						
					
				}

			//Vérification de la signature de la réponse
			$response=checkTransactionInfoResponse($finalizeWithThreeDSResponse, $certificate);
				
				if ($response['result'] == 1){	
				//signature valide
				
					//Vérification de l'errorCode
					//Si l'errorCode =0 on continu
					//sinon erreur technique
					
					if ($finalizeWithThreeDSResponse->errorCode==0){
					
						//Analyse du résultat du paiement
						//si tranasctionStatus = 8 ou 2 => Paiement refusé
						
						if (($finalizeWithThreeDSResponse->transactionStatus==8) OR ($finalizeWithThreeDSResponse->transactionStatus==2)){
						//Paiement refusé
						echo "Votre Paiement a été refusé";
						
						}else{
						//Paiement accepté
						
						/* 
						 *
						 * Ajouter ici le code pour mettre à jour votre base de données.
						 *
						 */
						
						echo "Merci pour votre achat";
						
						}
						
					}
					else{
					//erreur technique
						
						echo 'erreur technique';
					}
				}
				else{
				//signature invalide - Risque de fraude
					//La réponse est frauduleuse. On s'arrête	
					echo "Erreur technique";
					die;
				}		
			
				
			
			return $finalizeWithThreeDSResponse;
		}
}
?>