<?php
include_once 'php\classes\payzenApi.php';

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
<head>
	<meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/>
	<title>PayZen- Web services V4 - Interface de test</title>
	<link rel="stylesheet" type="text/css" href="./html/css/payzen.css" />
	
	<script type="text/javascript">
		<!--	
		
		function ouvrePopup(sPage, iLarg, iHaut){
			var iTop=(screen.height-iHaut)/2;
			var iLeft=(screen.width-iLarg)/2;
			window.open(sPage, "popup", "resizable=no, location=no, menubar=no, status=no, scrollbars=yes, top="+iTop+",left="+iLeft+",width="+iLarg+", height="+iHaut);
			return false;
		}
		
		function fermePopup(){
			opener = self;
			self.close();
		}
		
		function clickEvenement(param){				
				document.getElementById('createWithThreeDS').style.display = 'none';	
				document.getElementById('create').style.display = 'none';
				document.getElementById('getInfo').style.display = 'none';
				document.getElementById('result').style.display = 'none';				
				document.getElementById(param).style.display = 'block';				
			}
			
		-->		
	</script>	
</head>
<body style="position: relative; min-height: 100%; top: 0px;">


<div id="header" style="width:100%; height:74px; margin:0; padding:0; text-align:center;">
<h3>PayZen- Web services V4 - Interface de test</h3>
</div>

<div style="width:100%;padding:0px;margin:0px;">	
	<div id="leftcolumn">		
		<ul style="text-align:left;">Choix de la méthode
			<li><a href="#" onClick="clickEvenement('createWithThreeDS'); return false;">createWithThreeDS</a></li>
			<li><a href="#" onClick="clickEvenement('create'); return false;">create</a></li>
			<li><a href="#" onClick="clickEvenement('getInfo'); return false;">getInfo</a></li>
		</ul>
	</div>
	<div id="container">
	<?php
	//Vérification des données contenues dans le fichier config.ini
$config= parse_ini_file('/php/config.ini',true);	
	echo"Assurez-vous d'avoir renseigner le fichier /php/config.ini avant de commencer. <br/>"; 
	if ($config['webservices']['key'] == 1111111111111111){
		echo "Le champ 'key' n'est pas renseigné correctement avec votre certificat. <br/>";
	}
	if ($config['webservices']['siteId'] == 11111111){		
		echo "Le champ 'siteId' n'est pas renseigné correctement avec votre identifiant de boutique. <br/>";
	}
	if (stripos($config['webservices']['threeDsServerResponseUrl'], "monsite.fr") != false){		
		echo "Le champ 'threeDsServerResponseUrl' n'est pas renseigné correctement avec votre URL de retour. <br/>";
	}
	?>
	
	
	<?php
	function displayResult($result){	
		echo'			
			<table width="100%" cellspacing="0" cellpadding="0" >				
			<tr id="entete">
				<th>Nom du champ</th>
				<th>Valeur</th>									
			</tr>';					
			foreach ($result as $key=>$value){
				if (is_object($value)){
				echo '<tr><td style="padding:0px;">'.$key.'</td><td style="padding:0px;">';
				displayResult(get_object_vars($value));						
				echo "</td></tr>";
				}
				elseif (is_array($value)){
				echo '<tr><td style="padding:0px;">'.$key.'</td><td style="padding:0px;">';
				displayResult(array_values($value));						
				echo "</td></tr>";
				}
				else
				echo "<tr><td>".$key."</td><td>".$value."</td></tr>";
			}					
			echo'</table>';	
	}
	
		echo '<div id="result" '; 
		if (isset ($_POST['methode_name']))
		{ 
			echo'style="display:block;">';
			switch ($_POST['methode_name']) 
			{
				case "createWithThreeDS":
					include "./php/ws-v4_createWithThreeDS.php";
					$result= createWithThreeDS();
					break;
				case "finalizeWithThreeDS":	
					$result = $_POST['result'];
					displayResult($result);
					break;
				case "create":
					include "./php/ws-v4_create.php";
					$result = create();
					displayResult($result);
					break;
				case "getInfo":
					include "./php/ws-v4_getInfo.php";
					$result = getInfo();
					displayResult($result);
					break;
			}				
			
		echo '</div>';			
		}
		elseif (isset ($_POST['MD']) AND (isset ($_POST['PaRes']))){
			echo'style="display:block;">';
			include "./php/ws-v4_finalizeWithThreeDS.php";
			$result= finalizeWithThreeDS();
			displayResult($result);	
			echo '</div>';			
		}
		else{
		echo 'style="display:none;"></div>';
		}

		?>
	
		<div id="createWithThreeDS" style="display:none;">
			<!-- Nom de la méthode -->
			<h2>Création d’un paiement avec authentification 3D-Secure </h2>
			<!-- Descriptif de la méthode -->
			<p>La fonction createWithThreeDS permet de créer des paiements avec ou sans 3DS.<br/>
				Elle prend en entrée les paramètres suivants:
			</p>
			<!-- Tableau des paramètres d'entrée -->
				<table width="100%" cellspacing="0" cellpadding="0">			
					<tr class="entete">
						<th>Nom du champ</th>
						<th>Type</th>
						<th>Description</th>
						<th>Obligatoire</th>
					</tr>
					<tr>
						<td>createInfo</td>
						<td>createPaiementInfo</td>
						<td>cf. 4.1</td>					
						<td>oui</td>					
					</tr>
					<tr>
						<td>wsSignature</td>
						<td>String</td>
						<td>Signature</td>
						<td>oui</td>				
					</tr>	
				</table>
			<p>Cette fonction retourne une réponse du type <a href="#" onClick="ouvrePopup('./html/createWithThreeDSResponse.html','900','600'); return false;">createWithThreeDSResponse </a></p>
			<!-- Tableau des paramètres de sortie définis dans createWithThreeDSResponse.html-->		
			Les informations saisies dans le formulaire ci-dessous seront utilisées par le fichier /php/ws-v4_createWithThreeDS.php
			<!-- Formulaire de saisie des paramètres -->
			<form name="createWithThreeDS" action="index.php" method="post">
				<!-- Le script PHP est contenu dans le fichier ws-v4_createWithThreeDS.php -->	
				
			<!-- Formulaire de saisie des paramètres -->			
				<br/>
							
				<div class="cardDataInputBlock">
					<div class="titleContainer"><span class="titleValue">Formulaire de saisie</span></div>						
					<div style="float:left;">
					<h3><span class="paramLabel">Montant à payer</span></h3>
						<table class="infoTransactionTable">
						<tbody>
							<tr>
								<td class="InfosPayLeft"><span class="paramLabel">Numéro de commande<font color="RED" >*</font></span></td>
								<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="23" maxlength="64" name="orderId"  type="text"/>
										</span>
									</td>
							</tr>
							<tr>
								<td class="InfosPayLeft"><span class="paramLabel">Montant en euro<font color="RED" >*</font></span></td>
								<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="23" maxlength="12" name="amount"  type="text"/>
										</span>
									</td>		
								
							</tr>
						</tbody>
						</table>
					
					</div>
					<hr class="ensureDivHeight">
					
					<div style="float:left">					
						<h3><span class="paramLabel">Vos informations personnelles</span></h3>
						<table class="infoTransactionTable">
							<tbody>								
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Numéro d'abonné</span></td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="23" maxlength="20" name="cardIdent"  type="text"/>
										</span>
									</td>														
								</tr>								
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Référence client</span></td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="23" maxlength="80" name="customerId"  type="text"/>
										</span>
									</td>														
								</tr>
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Type</span></td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
											<select name="customerStatus" size="1" class="vads-expiry-date-input">								
												<option >   </option>
												<option value="COMPANY">  Entreprise </option>
												<option value="PRIVATE">  Particulier </option>
											</select>
										</span>
									</td>
								</tr>
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Civilité</span></td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
											<select name="customerTitle" size="1" class="vads-expiry-date-input">								
												<option >    </option>
												<option value="Mr">  Mr </option>
												<option value="Mlle">  Mlle </option>
												<option value="Mme">  Mme </option>
											</select>
										</span>
									</td>
								</tr>
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Nom client </span>
									</td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
											<input size="23" maxlength="128" name="customerName"  type="text"/>
										</span>
									</td>
								</tr>
								<tr>
										<td class="InfosPayLeft">
											<span class="paramLabel">Adresse email</span>
										</td>
										<td class="InfosPayCenter">:</td>
										<td class="InfosPayRight">
											<span class="paramInput">
											<input size="23" maxlength="150" name="customerMail"  type="text"/>
											</span>
										</td>								
								</tr>						
							</tbody>
						</table>				
					</div>
					<div style="float:left">
						<h3><span class="paramLabel">Votre adresse</span></h3>
						<table class="infoTransactionTable">
							<tbody>									
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Numéro de Rue</span>
									</td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="5" maxlength="5" name="customerAddressNumber"  type="text"/>
										</span>
									</td>
								</tr>
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Rue</span>
									</td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="23" maxlength="255" name="customerAddress"  type="text"/>
										</span>
									</td>
								</tr>
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Code postal</span>
									</td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="23" maxlength="64" name="customerZipCode"  type="text"/>
										</span>									
									</td>
								</tr>
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Quartier/Disctrict</span>
									</td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="23" maxlength="127" name="customerDistrict"  type="text"/>
										</span>
									</td>
								</tr>
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Ville</span>
									</td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="23" maxlength="128" name="customerCity"  type="text"/>
										</span>
									</td>
								</tr>
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Région/Etat</span>
									</td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="23" maxlength="128" name="customerState"  type="text"/>
										</span>
									</td>
								</tr>						
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Pays</span>
									</td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
											<select name="customerCountry" maxlength="40" size="1" class="vads-expiry-date-input">								
												<option >   </option>
												<option value="FR">  FR </option>											
												<option value="France">  France </option>											
											</select>
										</span>
									</td>
								</tr>								
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Téléphone</span>
									</td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="23" maxlength="32" name="customerPhone"  type="text"/>
										</span>
									</td>
								</tr>
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Téléphone Mobile</span>
									</td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="23" maxlength="32" name="customerMobilePhone"  type="text"/>
										</span>
									</td>
								</tr>									
							</tbody>
						</table>						
					</div>						
					<div id="paymentMeanChoiceBlock" style="float:left"width="330px">
						<h3><span class="paramLabel">Vos coordonnées bancaires</span></h3>					
						<div class="paymentMeanList">
							<label for="MASTERCARD" class="choiceLabel">
								<img src="./html/img/mastercard.gif" alt="Mastercard" title="Mastercard"/>
								<br/>
								<input type="radio" name="cardNetwork" id="MASTERCARD" value="MASTERCARD" title="Mastercard" checked="checked"/>
								<span>Mastercard</span>
							</label>
							<label for="MAESTRO" class="choiceLabel">
								<img src="./html/img/maestro.gif" alt="Maestro" title="Maestro" 
								onclick="javascript:try{this.parentNode.click();}catch(e){};checkEncapsulation();validateAndSubmit('MAESTRO');"/>
								<br/>
								<input type="radio" name="cardNetwork" id="MAESTRO" value="MAESTRO" title="Maestro" />
								<span>Maestro</span>
							</label>
							<label for="VISA" class="choiceLabel">
								<img src="./html/img/visa.gif" alt="Visa" title="Visa" 
								onclick="javascript:try{this.parentNode.click();}catch(e){};checkEncapsulation();validateAndSubmit('VISA');"/>
								<br/>
								<input type="radio" name="cardNetwork" id="VISA" value="VISA" title="Visa" />
								<span>Visa</span>
							</label>
							<label for="CB" class="choiceLabel">
								<img src="./html/img/cb.gif" alt="CB" title="CB" 
								onclick="javascript:try{this.parentNode.click();}catch(e){};checkEncapsulation();validateAndSubmit('CB');"/>
								<br/>
								<input type="radio" name="cardNetwork" id="CB" value="CB" title="CB" />
								<span>CB</span>
							</label>
							<label for="E-CARTEBLEUE" class="choiceLabel">
								<img src="./html/img/e-cartebleue.gif" alt="e-carteBleue" title="e-carteBleue" 
								onclick="javascript:try{this.parentNode.click();}catch(e){};checkEncapsulation();validateAndSubmit('E-CARTEBLEUE');"/>
								<br/>
								<input type="radio" name="cardNetwork" id="E-CARTEBLEUE" value="E-CARTEBLEUE" title="e-carteBleue" />
								<span>e-carteBleue</span>
							</label>
						</div>
					</div>								
					<div style="float:left">
						<span class="paramLabel">Numéro de carte :</span>
						<span class="paramInput">
						<input size="19" maxlength="19" name="cardNumber" value="4970100000000000" type="text"/>
						</span>
						<span class="paramLabel">Expire fin :</span> 
						<span class="paramInput">	 
							<select name="expiryMonth" size="1" class="vads-expiry-date-input">
								<option > mois </option>
								<option value="1">  01-Janvier </option>
								<option value="2">  02-Février </option>
								<option value="3">  03-Mars </option>
								<option value="4">  04-Avril </option>
								<option value="5">  05-Mai </option>
								<option value="6">  06-Juin </option>
								<option value="7">  07-Juillet </option>
								<option value="8">  08-Août </option>
								<option value="9">  09-Septembre </option>
								<option value="10">  10-Octobre </option>
								<option value="11">  11-Novembre </option>
								<option value="12" selected>  12-Décembre </option>
							</select>
						</span>
						<span class="paramLabel"> </span>
						<span class="paramInput">
							<select name="expiryYear" size="1">				
								<option > année </option>																
								<option value="2014"> 2014</option>				
								<option value="2015"> 2015</option>				
								<option value="2016"> 2016</option>				
								<option value="2017"> 2017</option>				
								<option value="2018"> 2018</option>				
								<option value="2019"> 2019</option>				
								<option value="2020"> 2020</option>				
								<option value="2021" selected> 2021</option>
							</select>
						</span>
						<br/>
						<br/>					
						<span class="paramLabel">Cryptogramme visuel de la carte :</span>
						<span class="paramInput">
						<input id="cvvid" size="2" maxlength="3" name="cvv"  type="text"/>									
					</span>	
					</div>
					<hr class="ensureDivHeight">
					<br/>
					<br/>
					<div style="text-align:center">
					<input type="hidden" name="methode_name" value="createWithThreeDS" />
					<input type="submit" id="createWith3DSButton" value="Payer"/> 					
					</div>
				<hr class="ensureDivHeight">
				</div>	
				</form>		
		</div>

	
	<div id="create" style="display:none;">
			<!-- Nom de la méthode -->
			<h2>Création d’un paiement avec 3D-Secure externe ou sans 3D-Secure </h2>
			<!-- Descriptif de la méthode -->
			<p>La fonction create permet de créer des paiements avec ou sans 3DS.<br/>
				Elle prend en entrée les paramètres suivants:
			</p>
						
			
			<!-- Tableau des paramètres d'entrée -->
				<table width="100%" cellspacing="0" cellpadding="0">			
					<tr class="entete">
						<th>Nom du champ</th>
						<th>Type</th>
						<th>Description</th>
						<th>Obligatoire</th>
					</tr>
					<tr>
						<td>createInfo</td>
						<td>paymentCreationInfo</td>
						<td>cf. 4.26</td>					
						<td>oui</td>					
					</tr>
					<tr>
						<td>wsSignature</td>
						<td>String</td>
						<td>Signature</td>
						<td>oui</td>				
					</tr>	
				</table>
			<p>Cette fonction retourne une réponse du type <a href="#" onClick="ouvrePopup('./html/transactionInfo.html','900','600'); return false;">transactionInfo </a></p>
			<!-- Tableau des paramètres de sortie définis dans createWithThreeDSResponse.html-->		
			Les informations saisies dans le formulaire ci-dessous seront utilisées par le fichier /php/ws-v4_create.php
			<!-- Formulaire de saisie des paramètres -->
			<form name="create" action="index.php" method="post">
				<!-- Le script PHP est contenu dans le fichier ws-v4_createWithThreeDS.php -->	
				
			<!-- Formulaire de saisie des paramètres -->			
				<br/>
							
				<div class="cardDataInputBlock">
					<div class="titleContainer"><span class="titleValue">Formulaire de saisie</span></div>						
					<div style="float:left;">
					<h3><span class="paramLabel">Montant à payer</span></h3>
						<table class="infoTransactionTable">
						<tbody>
							<tr>
								<td class="InfosPayLeft"><span class="paramLabel">Numéro de commande<font color="RED" >*</font></span></td>
								<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="23" maxlength="64" name="orderId"  type="text"/>
										</span>
									</td>
							</tr>
							<tr>
								<td class="InfosPayLeft"><span class="paramLabel">Montant en euro<font color="RED" >*</font></span></td>
								<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="10" maxlength="12" name="amount" type="text"/>
										</span>
									</td>		
								
							</tr>
						</tbody>
						</table>
					
					</div>
					<hr class="ensureDivHeight">
					
					<div style="float:left">					
						<h3><span class="paramLabel">Vos informations personnelles</span></h3>
						<table class="infoTransactionTable">
							<tbody>								
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Numéro d'abonné</span></td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="23" maxlength="" name="cardIdent" type="text"/>
										</span>
									</td>														
								</tr>								
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Référence client</span></td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="23" maxlength="80" name="customerId" type="text"/>
										</span>
									</td>														
								</tr>
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Type</span></td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
											<select name="customerStatus" size="1" class="vads-expiry-date-input">								
												<option >   </option>
												<option value="COMPANY">  Entreprise </option>
												<option value="PRIVATE">  Particulier </option>
											</select>
										</span>
									</td>
								</tr>
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Civilité</span></td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
											<select name="customerTitle" size="1" class="vads-expiry-date-input">								
												<option >    </option>
												<option value="Mr">  Mr </option>
												<option value="Mlle">  Mlle </option>
												<option value="Mme">  Mme </option>
											</select>
										</span>
									</td>
								</tr>
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Nom client </span>
									</td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
											<input size="23" maxlength="128" name="customerName"  type="text"/>
										</span>
									</td>
								</tr>
								<tr>
										<td class="InfosPayLeft">
											<span class="paramLabel">Adresse email</span>
										</td>
										<td class="InfosPayCenter">:</td>
										<td class="InfosPayRight">
											<span class="paramInput">
											<input size="23" maxlength="150" name="customerEmail"  type="text"/>
											</span>
										</td>								
								</tr>						
							</tbody>
						</table>				
					</div>
					<div style="float:left">
						<h3><span class="paramLabel">Votre adresse</span></h3>
						<table class="infoTransactionTable">
							<tbody>									
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Numéro de Rue</span>
									</td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="5" maxlength="5" name="customerAddressNumber"  type="text"/>
										</span>
									</td>
								</tr>
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Rue</span>
									</td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="23" maxlength="255" name="customerAddress" type="text"/>
										</span>
									</td>
								</tr>
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Code postal</span>
									</td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="23" maxlength="64" name="customerZipCode" type="text"/>
										</span>									
									</td>
								</tr>
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Quartier/Disctrict</span>
									</td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="23" maxlength="127" name="customerDistrict" type="text"/>
										</span>
									</td>
								</tr>
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Ville</span>
									</td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="23" maxlength="128" name="customerCity" type="text"/>
										</span>
									</td>
								</tr>
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Région/Etat</span>
									</td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="23" maxlength="128" name="customerState" type="text"/>
										</span>
									</td>
								</tr>						
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Pays</span>
									</td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
											<select name="customerCountry" maxlength="40" size="1" class="vads-expiry-date-input">								
												<option >   </option>
												<option value="France">  France </option>											
												<option value="FR">  FR </option>
											</select>
										</span>
									</td>
								</tr>								
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Téléphone</span>
									</td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="23" maxlength="32" name="customerPhone" type="text"/>
										</span>
									</td>
								</tr>
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Téléphone Mobile</span>
									</td>
									<td class="InfosPayCenter">:</td>
									<td class="InfosPayRight">
										<span class="paramInput">
										<input size="23" maxlength="32" name="customerCellPhone" type="text"/>
										</span>
									</td>
								</tr>									
							</tbody>
						</table>						
					</div>						
					<div id="paymentMeanChoiceBlock" style="float:left"width="330px">
						<h3><span class="paramLabel">Vos coordonnées bancaires</span></h3>					
						<div class="paymentMeanList">
							<label for="MASTERCARD" class="choiceLabel">
								<img src="./html/img/mastercard.gif" alt="Mastercard" title="Mastercard"/>
								<br/>
								<input type="radio" name="cardNetwork" id="MASTERCARD" value="MASTERCARD" title="Mastercard" checked="checked"/>
								<span>Mastercard</span>
							</label>
							<label for="MAESTRO" class="choiceLabel">
								<img src="./html/img/maestro.gif" alt="Maestro" title="Maestro" 
								onclick="javascript:try{this.parentNode.click();}catch(e){};checkEncapsulation();validateAndSubmit('MAESTRO');"/>
								<br/>
								<input type="radio" name="cardNetwork" id="MAESTRO" value="MAESTRO" title="Maestro" />
								<span>Maestro</span>
							</label>
							<label for="VISA" class="choiceLabel">
								<img src="./html/img/visa.gif" alt="Visa" title="Visa" 
								onclick="javascript:try{this.parentNode.click();}catch(e){};checkEncapsulation();validateAndSubmit('VISA');"/>
								<br/>
								<input type="radio" name="cardNetwork" id="VISA" value="VISA" title="Visa" />
								<span>Visa</span>
							</label>
							<label for="CB" class="choiceLabel">
								<img src="./html/img/cb.gif" alt="CB" title="CB" 
								onclick="javascript:try{this.parentNode.click();}catch(e){};checkEncapsulation();validateAndSubmit('CB');"/>
								<br/>
								<input type="radio" name="cardNetwork" id="CB" value="CB" title="CB" />
								<span>CB</span>
							</label>
							<label for="E-CARTEBLEUE" class="choiceLabel">
								<img src="./html/img/e-cartebleue.gif" alt="e-carteBleue" title="e-carteBleue" 
								onclick="javascript:try{this.parentNode.click();}catch(e){};checkEncapsulation();validateAndSubmit('E-CARTEBLEUE');"/>
								<br/>
								<input type="radio" name="cardNetwork" id="E-CARTEBLEUE" value="E-CARTEBLEUE" title="e-carteBleue" />
								<span>e-carteBleue</span>
							</label>
						</div>
					</div>								
					<div style="float:left">
						<span class="paramLabel">Numéro de carte :</span>
						<span class="paramInput">
						<input size="19" maxlength="19" name="cardNumber" value="4970100000000000" type="text"/>
						</span>
						<span class="paramLabel">Expire fin :</span> 
						<span class="paramInput">	 
							<select name="expiryMonth" size="1" class="vads-expiry-date-input">
								<option > mois </option>
								<option value="1">  01-Janvier </option>
								<option value="2">  02-Février </option>
								<option value="3">  03-Mars </option>
								<option value="4">  04-Avril </option>
								<option value="5">  05-Mai </option>
								<option value="6">  06-Juin </option>
								<option value="7">  07-Juillet </option>
								<option value="8">  08-Août </option>
								<option value="9">  09-Septembre </option>
								<option value="10">  10-Octobre </option>
								<option value="11">  11-Novembre </option>
								<option value="12" selected>  12-Décembre </option>
							</select>
						</span>
						<span class="paramLabel"> </span>
						<span class="paramInput">
							<select name="expiryYear" size="1">				
								<option > année </option>												
								<option value="2014"> 2014</option>				
								<option value="2015"> 2015</option>				
								<option value="2016"> 2016</option>				
								<option value="2017"> 2017</option>				
								<option value="2018"> 2018</option>				
								<option value="2019"> 2019</option>				
								<option value="2020"> 2020</option>				
								<option value="2021" selected> 2021</option>
								
							</select>
						</span>
						<br/>
						<br/>					
						<span class="paramLabel">Cryptogramme visuel de la carte :</span>
						<span class="paramInput">
						<input id="cvvid" size="2" maxlength="3" name="cvv" value ="111" type="text"/>									
					</span>	
					</div>
					<hr class="ensureDivHeight">
					<br/>
					<br/>
					<div style="text-align:center">
					<input type="hidden" name="methode_name" value="create" />
					<input type="submit" id="createButton" value="Payer"/> 					
					</div>
				<hr class="ensureDivHeight">
				</div>	
				</form>		
		</div>

	
	<div id="getInfo" style="display:none;">
				<!-- Nom de la méthode -->
				<h2>Recherche des détails d’une transaction </h2>
				<!-- Descriptif de la méthode -->
				<p>La fonction getInfo permet d’interroger une transaction pour en connaître ses différents attributs<br/>
					Elle prend en entrée les paramètres suivants:
				</p>
				<!-- Tableau des paramètres d'entrée -->
					<table width="100%" cellspacing="0" cellpadding="0">			
						<tr class="entete">
							<th>Nom du champ</th>
							<th>Format</th>
							<th>Description</th>
							<th>Obligatoire</th>
						</tr>
						<tr>
							<td>siteId</td>
							<td>string / n8</td>
							<td>Identifiant de la boutique</td>					
							<td>oui</td>					
						</tr>
						<tr>
							<td>transmissionDate</td>
							<td>dateTime / ans..40</td>
							<td>Date et heure de création  de la transaction à rechercher</td>					
							<td>oui</td>					
						</tr>
						<tr>
							<td>transactionId</td>
							<td>string / n6</td>
							<td>Identifiant de la transaction à rechercher </td>					
							<td>oui</td>					
						</tr>
						<tr>
							<td>sequenceNumber</td>
							<td>string / n..3</td>
							<td>Numéro de séquence de la transaction</td>					
							<td>oui</td>					
						</tr>
						<tr>
							<td>ctxMode</td>
							<td>string</td>
							<td>Contexte de sollicitation de la plateforme </td>					
							<td>oui</td>					
						</tr>
						<tr>
							<td>wsSignature</td>
							<td>String</td>
							<td>Signature</td>
							<td>oui</td>				
						</tr>	
					</table>
				<p>Cette fonction retourne une réponse du type <a href="#" onClick="ouvrePopup('./html/transactionInfo.html','900','600'); return false;">transactionInfo </a></p>
				<!-- Tableau des paramètres de sortie définis dans transactionInfo.html-->		
				Les informations saisies dans le formulaire ci-dessous seront utilisées par le fichier /php/ws-v4_getInfo.php
				<!-- Formulaire de saisie des paramètres -->
				<form name="getInfo" action="index.php" method="post">
					<!-- Le script PHP est contenu dans le fichier ws-v4_getInfo.php -->	
					
				<!-- Formulaire de saisie des paramètres -->			
					<br/>
								
					<div class="cardDataInputBlock">
						<div class="titleContainer"><span class="titleValue">Formulaire de saisie</span></div>						
						<div style="float:left;">
						<h3><span class="paramLabel">Recherche d'une transaction</span></h3>
							<table class="infoTransactionTable">
							<tbody>
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Id de transaction<font color="RED" >*</font></span></td>
									<td class="InfosPayCenter">:</td>
										<td class="InfosPayRight">
											<span class="paramInput">
											<input size="23" maxlength="6" name="transactionId"  type="text"/>
											</span>
										</td>
								</tr>
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Date et heure<font color="RED" >*</font></span></td>
									<td class="InfosPayCenter">:</td>
										<td class="InfosPayRight">
											<span class="paramInput">
											<input size="23" maxlength="25" name="transmissionDate"  type="text"/>
											</span>
										</td>		
									
								</tr>
								<tr>
									<td class="InfosPayLeft"><span class="paramLabel">Numéro de séquence<font color="RED" >*</font></span></td>
									<td class="InfosPayCenter">:</td>
										<td class="InfosPayRight">
											<span class="paramInput">
											<input size="23" maxlength="3" name="sequenceNumber"  type="text"/>
											</span>
										</td>
								</tr>
							</tbody>
							</table>
						
						</div>
						<hr class="ensureDivHeight">
						
						<br/>
						<br/>
						<div style="text-align:center">
						<input type="hidden" name="methode_name" value="getInfo" />
						<input type="submit" id="getInfoButtonButton" value="Rechercher"/> 					
						</div>
					<hr class="ensureDivHeight">
					</div>	
					</form>		
	</div>

	
	<div id="rightcolumn">
	</div>
	

</div>


</body>
</html>