<?php
function getInfo() {
header('Content-Type: text/html; charset=utf-8');
session_start();


include_once 'classes\StandardWS.php';
include_once 'classes\payzenApi.php';
$config= parse_ini_file('config.ini',true);	

$certificate = $config['webservices']['key'];	
$vads=new StandardWS;
	
	/****************************************************************/
		
		$siteId = $config['webservices']['siteId'];	
		$ctxMode = $config['webservices']['ctxMode'];		
		
	/****************************************************************/
		/*
		Informations sur la transaction
		*/
		if (!empty($_POST['transactionId'])) $transactionId = $_POST['transactionId']; 	
		if (!empty($_POST['transmissionDate'])) $transmissionDate = new DateTime($_POST['transmissionDate'],new DateTimeZone('UTC'));		
		if (!empty($_POST['sequenceNumber'])) $sequenceNumber = $_POST['sequenceNumber'];	
				
	/****************************************************************/
	
	
	$getInfoResponse= new transactionInfo();	
	try {
		$getInfoResponse=$vads->getInfo($siteId, $transmissionDate, $transactionId, $sequenceNumber, $ctxMode, $certificate);
	}catch (Exception $e){
                 echo $e->getMessage();
				 }
	getJsessionId($vads);
	/*Affichage des logs XML*/
	if ($config['webservices']['debugXML']=='ON'){
		echo "<hr> [Request Header] <br/>", htmlspecialchars($vads->__getLastRequestHeaders()), "<br/>";
		echo "<hr> [Request] <br/>", htmlspecialchars($vads->__getLastRequest()), "<br/>";	
		echo "<hr> [Response Header]<br/>", htmlspecialchars($vads->__getLastResponseHeaders()), "<br/>";
		echo "<hr> [Response]<br/>", htmlspecialchars($vads->__getLastResponse()), "<br/>";
		echo '<hr>';		
		
	}	
	
	//Vrification de la signature de la rponse
	$response=checkTransactionInfoResponse($getInfoResponse, $certificate);
	
		
	if ($response['result'] == 1){	
	//signature valide
	
		//Vrification de l'errorCode
		//Si l'errorCode =0 on continu
		//sinon erreur technique
		
		if ($getInfoResponse->errorCode==0){	
						
			/* 
			 *
			 * Ajouter ici le code pour mettre  jour votre base de donnes.
			 *
			 */			
				
		}
		else{
		//erreur technique
			echo 'erreur technique';
			die;
		}
	}
	else{
	//signature invalide - Risque de fraude
		//La rponse est frauduleuse. On s'arrte	
		echo "Erreur technique";
		die;
	}
	
	
	return $getInfoResponse;	
}	
?>