<?php
function modify() {
header('Content-Type: text/html; charset=utf-8');
session_start();


include_once 'classes\StandardWS.php';
include_once 'classes\payzenApi.php';
$config= parse_ini_file('config.ini',true);	

$certificate = $config['webservices']['key'];	
$vads=new StandardWS;
	
	/****************************************************************/
		
		$siteId = $config['webservices']['siteId'];	
		$ctxMode = $config['webservices']['ctxMode'];		
		$currency = $config['webservices']['currency'];		
		
	/****************************************************************/
		/*
		Informations sur la transaction
		*/
		if (!empty($_POST['transactionId'])) $transactionId = $_POST['transactionId']; 	
		if (!empty($_POST['transmissionDate'])) $transmissionDate = new DateTime($_POST['transmissionDate'],new DateTimeZone('UTC'));		
		if (!empty($_POST['sequenceNumber'])) $sequenceNumber = $_POST['sequenceNumber'];	
		if (!empty($_POST['amount'])) $amount = $_POST['amount'];	
		if (!empty($_POST['presentationDate'])) $presentationDate = new DateTime($_POST['presentationDate'],new DateTimeZone('UTC'));		
		if (!empty($_POST['validate'])) $validate = $_POST['validate'];	
		if (!empty($_POST['comment'])) $comment = $_POST['comment'];	
				
	/****************************************************************/
	
	
	
	$ModifyResponse= new transactionInfo();	
	try {
		$ModifyResponse=$vads->modify($siteId, $transmissionDate, $transactionId, $sequenceNumber, $ctxMode, $amount, $currency, $presentationDate, $validate, $comment, $certificate);
	}catch (Exception $e){
                 echo $e->getMessage();
				 }
	getJsessionId($vads);
	/*Affichage des logs XML*/
	if ($config['webservices']['debugXML']=='ON'){
		echo "<hr> [Request Header] <br/>", htmlspecialchars($vads->__getLastRequestHeaders()), "<br/>";
		echo "<hr> [Request] <br/>", htmlspecialchars($vads->__getLastRequest()), "<br/>";	
		echo "<hr> [Response Header]<br/>", htmlspecialchars($vads->__getLastResponseHeaders()), "<br/>";
		echo "<hr> [Response]<br/>", htmlspecialchars($vads->__getLastResponse()), "<br/>";
		echo '<hr>';		
		
	}	
	
	//Vrification de la signature de la rponse
	$response=checkTransactionInfoResponse($ModifyResponse, $certificate);
	
			/* 
			 * Vrifiez l'erreur code et le transactionStatus
			 * Ajouter ensuite le code pour mettre  jour votre base de donnes.
			 *
			 */
	
	
	return $ModifyResponse;
}	
?>